//  Delphi sample of using Win32 keyboard hooks and memory mapped files.
//  The purpose of program is catching some "magic" numbers entered from
//  keyboard and displaying them with toggled words in popup window.
//
//  Main executable
//  (c) Almaz Sharipov

program hook;
uses sysutils, windows;

var sPath, Pass, NNN, SS   : String;
    DLL                    : HINST;
    ProcAddr, Map1, Map2   : Pointer;
    msg                    : TMsg;
    f                      : textfile;
    MapHandle1, MapHandle2 : THandle;

begin

// Load numbers list from file into a raw string

 AssignFile(f, ExtractFilePath(ParamStr(0)) + Paramstr(1));
 Reset(f);
 while not eof(f) do begin
   Readln(f, SS);
   Pass := Pass + SS + ' ';
 end;
 CloseFile(f);

// System keyboard callback procedure must be placed into DLL so 
// the easiest way of sharing the keyboard buffer and magic numbers
// among different processes is to use the memory mapped files.
// Warning: no check for possible failures is implemented.
 
 MapHandle1 := CreateFileMapping($ffffffff, nil, PAGE_READWRITE, 0, 64000, PChar('NUMBERLIST'));
 Map1 := MapViewOfFile(MapHandle1, FILE_MAP_WRITE, 0, 0, 64000);
 StrPCopy(Map1, Pass);
 FlushViewOfFile(Map1, 64000);
 UnMapViewOfFile(Map1);

 MapHandle2 := CreateFileMapping($ffffffff, nil, PAGE_READWRITE, 0, 16, PChar('BUFFER'));
 Map2 := MapViewOfFile(MapHandle2, FILE_MAP_WRITE, 0, 0, 16);
 StrPCopy(Map2, NNN);
 FlushViewOfFile(Map2, 16);
 UnMapViewOfFile(Map2);

//--- Set hook to DLL procedure

 sPath := ExtractFilePath(ParamStr(0)) + 'keyhook.dll';
 DLL := LoadLibrary(PChar(sPath));
 ProcAddr := GetProcAddress(DLL, PChar('KeyboardProc'));
 SetWindowsHookEx(WH_KEYBOARD, ProcAddr, DLL, 0);

//--- Main message loop

 while (GetMessage(msg, 0, 0, 0)) do
   begin
       TranslateMessage(msg);
       DispatchMessage(msg);
   end;
end.
